!IM    Implemente en modes sequentiel et parallele

       CALL gather(rlat,rlat_glo)
       CALL bcast(rlat_glo)
       CALL gather(rlon,rlon_glo)
       CALL bcast(rlon_glo)

!$OMP MASTER
      if (is_mpi_root) then
!
       zstophy = pdtphys
       zout = mth_len*un_jour
!
       idayref = day_ref
       CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
!
       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlon_glo,zx_lon)
       if (nbp_lon.gt.1) then
       DO i = 1, nbp_lon
         zx_lon(i,1) = rlon_glo(i+1)
         zx_lon(i,nbp_lat) = rlon_glo(i+1)
       ENDDO
       endif
       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlat_glo,zx_lat)
!
       CALL histbeg("paramLMDZ_phy.nc",  &
                       np,zx_lon(np:np,1), np,zx_lat(1,np:np), &
                       1,1,1,1, &
                       itau_phy, zjulian, dtime, &
                       nhori, nid_ctesGCM)
!
       CALL histdef(nid_ctesGCM, "R_ecc",  &
                      "Excentricite","-", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "R_peri",  &
                      "Equinoxe","-", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "R_incl",  &
                      "Inclinaison","deg", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "solaire",  &
                      "Constante solaire","W/m2", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "co2_ppm",  &
                      "Concentration du CO2", "ppm", &
                      1,1,nhori, 1,1,1, -99, 32,  &
                      "ave(X)", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "CH4_ppb",  &
                      "Concentration du CH4", "ppb", &
                      1,1,nhori, 1,1,1, -99, 32,  &
                      "ave(X)", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "N2O_ppb", &
                      "Concentration du N2O", "ppb", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave(X)", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "CFC11_ppt", &
                      "Concentration du CFC11", "ppt", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave(X)", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "CFC12_ppt", &
                      "Concentration du CFC12", "ppt", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave(X)", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "bils", &
                      "Surface total heat flux", "W m-2", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "evap", &
                      "Evaporation", "kg m-2 s-1", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "evap_land", &
                      "Land evaporation", "kg m-2 s-1", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "flat", &
                      "Latent heat flux", "W m-2", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "nettop0", &
                      "Clear sky net downward radiatif flux at TOA",  &
                      "W m-2", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "nettop", &
                      "Net downward radiatif flux at TOA", "W m-2", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "precip", &
                      "Total precipitation (liq+sol)", "kg m-2 s-1", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "tsol", &
                      "Surface temperature", "K", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "t2m", &
                      "Temperature at 2m", "K", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout)
!
       CALL histdef(nid_ctesGCM, "prw", &
                      "Precipitable water", "kg m-2", &
                      1,1,nhori, 1,1,1, -99, 32, &
                      "ave", zstophy,zout) 
!=================================================================
!
       CALL histend(nid_ctesGCM)
       
       endif !(is_mpi_root)
!$OMP END MASTER
!=================================================================
